<?php
/**
 * Display class for 3dmlw administration.
 */

defined('_JEXEC') or die('Restricted access');
jimport('pattemplate.patTemplate');

class display{

	/**
	 * Static method to create the template object
	 * @return patTemplate
	 */
	function &createFactoryTemplate($filename) {
		global $option, $mosConfig_absolute_path, $mainframe;


		$tmpl =& patFactory::createTemplate( $option, true, false );
		$tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );
        $tmpl->setAttribute( 'body', 'src', $filename );

		return $tmpl;
	}

	/**
	 * Creates a patTemplate object and retrieves the template files form tmpl directory.
	 * @param $filename Name of the template file.
	 * @return patTemplate object.
	 */
	function &createTemplate($filename){
		global $mosConfig_absolute_path;

		$tmpl =& new patTemplate();
		$tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );

		$tmpl->readTemplatesFromInput($filename);

		return $tmpl;
	}

	/**
	 * Basic 3dmlw file display.
	 * $file Href of the file.
	 * $params Parameters of the 3dmlw, width, height.
	 */
	function file($file, &$params){
		$width = $params->get('width', 800);
		$height = $params->get('height', 600);

		$tmpl =& display::createTemplate('3dmlw.html');
		$href= $file->getHref();
		$tmpl->addVar('3dmlw', 'filename', $href);
		$tmpl->addVar('3dmlw', 'width', $width);
		$tmpl->addVar('3dmlw', 'height', $height);

		$tmpl->displayParsedTemplate('3dmlw');
	}

	/**
	 * Displays a generic view of 3dmlw file with tile and 3dmlw view
	 * @param
	 * @return
	 * @version version
	 * @since moduleversion Aug 23, 2008
	 */
	function view($mlw, &$params){
		$tmpl  =& display::createTemplate('view.html');

		$width = $params->get('width', 800);
		$height = $params->get('height', 600);
		$href= $mlw->getHref();

		$tmpl->addVar('view', 'title', $mlw->getTitle());
		$tmpl->addVar('view', 'filename', $href);
		$tmpl->addVar('view', 'width', $width);
		$tmpl->addVar('view', 'height', $height);

		$tmpl->displayParsedTemplate('view');
	}

	function edit($mlw){
		global $option;
		$document =& JFactory::getDocument();
		$document->addStyleSheet("components/$option/assets/edit.css");
		$tmpl =& display::createTemplate('edit.html');
		$tmpl->addObject('edit', $mlw);
		$tmpl->displayParsedTemplate();
	}

	function editor( $name){
		$live_site = JURI::root() . 'images/';

	?>
	<script type="text/javascript">
		function insertMLW(editor){
			var folder = document.getElementById('currentFolder').value;

			if(!folder) folder = '';

			var file = getFile();
			if(file){
				var href = "<?php echo $live_site ?>" + folder +  file;
				var html = create3DMLW(href);
				window.parent.jInsertEditorText(html, editor );
				return false;
			}else{
				alert('No file has been selected');
			}
		}

		function create3DMLW(href){
			return "<div><object classid=\'clsid:A3F45AE8-DEDE-4B21-BBFB-0EC7724E06EC\'" +
					"id=\"3DMLW_plugin\" type=\"text/3dmlw\" " +
  					"codebase=\"http://www.3dmlw.com/download/3dmlw_installer.exe\" " +
  					"height=\"600\" width=\"800\">" +
 					"<param name=\"source\" value=\"" + href + '">' +
					"<embed id=\"3DMLW_plugin2\" " +
					"source=\"" + href + "\" type=\"text/3dmlw\" pluginspage=\"http://www.3dmlw.com/download/3dmlw_installer.exe\" " +
					"height=\"800\" width=\"600\">" +
  					"</embed></object></div>";

//  		return "<h2>Testing</h2>";
		}

		function getFile(){
			var filelist = window.frames['fileframe'].document.getElementById('filelist');
			var inputEl = filelist.getElementsByTagName('input');
			for(i = 0; i < inputEl.length; i++){
				if(inputEl[i].checked)
					return inputEl[i].value;
			}
			return null;
		}
	</script>
	<div style="float: right;">
		<button onclick="insertMLW('<?php echo $name ?>'); window.parent.document.getElementById('sbox-window').close();" type="button">Insert</button>
		<button onclick="window.parent.document.getElementById('sbox-window').close();" type="button">Cancel</button>
	</div><br />

	<?php
	}

	function listX($list, $limitstart, $limit, $total){
		jimport('joomla.html.pagination');
		global $option;
		$pagination =& new JPagination($total, $limitstart, $limit);
		$document =& JFactory::getDocument();

//		echo "Limit start: $limitstart<br /> Limit: $limit <br>Total: $total";

		?>
		<div id="mlw3d"><form name="adminForm" method="post" ><table class="adminlist">
		<thead><tr>
			<th width="5">#</th>
			<th width="5">
				<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $list ); ?>);" />
			</th>
			<th class="title" width="10">Published</th>
			<th class="title" width="100">Title</th><th class="title">Desciption</th></tr>
		<thead><tbody>
		<?php
		$mlw =& new FileTable( JFactory::getDBO() );

		for ($i = 0; $i < count($list); $i++) {
			$mlw->clear();
			$mlw->bind($list[$i]);
			$id = JHTML::_( 'grid.id', $i + 1, $mlw->id);
			$name = $mlw->getTitle();
			$description = $mlw->description;
			$publish = JHTML::_('grid.published', $mlw, $i + 1);
			$href = JRoute::_('index.php?option=com_3dmlw&task=edit&id=' . $list[$i]->id );
			?>
			 <tr>
			 	<td><?php echo ($i + 1); ?></td>
				<td><?php echo $id ?></td>
				<td style="text-align:center"><?php echo $publish; ?>
			 	<td class="title">
			 		<a href="<?php echo $href; ?>" ><?php echo $name ?></a>
			 	</td>
			 	<td><?php echo $description ?></td>
			 </tr>
			<?php
		}

		if(!count($list)){
			echo '<tr><td colspan="5" style="text-align:center">' . JText::_('NOITEMS') . '</td></tr>';
		}

		?>
		<tfoot>
		<tr>
			<td colspan="5">
				<?php echo $pagination->getListFooter(); ?>
			</td>
		</tr></tfoot></tbody>
			</table>
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="task" value="" />
			<input type="hidden" name="option" value="<?php echo $option; ?>" />
			</form>
		</div>
		<?php
	}
}
?>
