<?php

/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');
//require_once( $mosConfig_absolute_path . '/includes/patTemplate/patTemplate.php' );
jimport('pattemplate.patTemplate');

class display{

	/**
	 * Static method to create the template object
	 * @return patTemplate
	 */
	function &createFactoryTemplate($filename) {
		global $option, $mosConfig_absolute_path, $mainframe;


		$tmpl =& patFactory::createTemplate( $option, true, false );
		$tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );
        $tmpl->setAttribute( 'body', 'src', $filename );

		return $tmpl;
	}

	/**
	 * Creates a patTemplate object and retrieves the template files form tmpl directory.
	 * @param $filename Name of the template file.
	 * @return patTemplate object.
	 */
	function &createTemplate($filename){
		global $mosConfig_absolute_path;

		$tmpl =& new patTemplate();
		$tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );

		$tmpl->readTemplatesFromInput($filename);

		return $tmpl;
	}

	/**
	 * Basic 3dmlw file display.
	 * $file Href of the file.
	 * $params Parameters of the 3dmlw, width, height.
	 */
	function file($file, &$params){
		$width = $params->get('width', 800);
		$height = $params->get('height', 600);

		$tmpl =& display::createTemplate('3dmlw.html');
		$href= $file->getHref();
		$tmpl->addVar('3dmlw', 'filename', $href);
		$tmpl->addVar('3dmlw', 'width', $width);
		$tmpl->addVar('3dmlw', 'height', $height);

		$tmpl->displayParsedTemplate('3dmlw');
	}

	/**
	 * Displays a generic view of 3dmlw file with tile and 3dmlw view
	 * @param
	 * @return
	 * @version version
	 * @since moduleversion Aug 23, 2008
	 */
	function view($mlw, &$params){
		$tmpl  =& display::createTemplate('view.html');

		$width = $params->get('width', 800);
		$height = $params->get('height', 600);
		$href= $mlw->getHref();

		$tmpl->addVar('view', 'title', $mlw->getTitle());
		$tmpl->addVar('view', 'filename', $href);
		$tmpl->addVar('view', 'description', $mlw->description);
		$tmpl->addVar('view', 'width', $width);
		$tmpl->addVar('view', 'height', $height);
		$tmpl->addVar('view', 'CENTER', (int)($width/2 - 151));
		$tmpl->displayParsedTemplate('view');
	}

	function uploadform(){
		global $option;
		$document =& JFactory::getDocument();
		$document->addStyleSheet("components/$option/assets/upload.css");
		$tmpl =& display::createTemplate('upload.html');
		$tmpl->displayParsedTemplate();
	}

	function listX($list, $limitstart, $limit, $total){
		jimport('joomla.html.pagination');
		global $option, $mainframe;
		$onclick = '';
		$pagination =& new JPagination($total, $limitstart, $limit);
		$document =& JFactory::getDocument();
		$document->addStyleSheet("components/$option/assets/3dmlw.css");
		$params =& $mainframe->getPageParameters();
		$mlw =& new FileTable( JFactory::getDBO() );
		$pageTile = $params->get('page_title', '');



		if($params->get('show_page_title')){
		?>
		<div class="componentheading"><?php echo $pageTile ?></div>
		<?php }	?>
		<div id="mlw3d">
			<table cellpadding="3" width="100%">
				<tr >
					<td class="sectiontableheader" width="35%">Title</td>
					<td class="sectiontableheader" width="65%">Desciption</td>
				</tr>

		<?php

		$length = count($list);

		if($params->get('popup')){
			$host = JURI::root();
			$width = $params->get('width', 800) + 20;
			$height = $params->get('height', 600) + 20;
			$js = 'function openWindow( id ){
				var url = "' . $host . 'index.php?option=com_3dmlw&format=component&task=display&id=" + id + \'"\';
				window.open(url, "mlw", "resizable=no,width='. $width . ',height=' . $height . '");
				return false;
			} ';

			$document->addScriptDeclaration($js);
		}

		if($length){
			for ($i = 0; $i < $length; $i++) {
				$mlw->clear();
				$mlw->bind($list[$i]);
				$name = $mlw->getTitle();
				$description = $mlw->description;

				$href = JRoute::_('index.php?option=com_3dmlw&task=display&id=' . $mlw->id );
				$j = ($i % 2) + 1;
				if($params->get('popup')){
					$onclick = 'onclick="openWindow( ' . $mlw->id . ' ); return false;"';
					$href ="#";
				}

				echo "<tr class=\"sectiontableentry{$j}\" >" .
						"<td class=\"title\"><a $onclick href=\"{$href}\" >$name</a></td>" .
						"<td class=\"description\">$description</td></tr>";
			}
		}else{
			echo '<tr><td colspan="2" style="text-align:center">' . JText::_('NOITEMS') . '</td></tr>';
		}

		?>
		<tr class="footer-row">
			<td colspan="2">
				<form name="adminForm" method="post" >
				<?php echo $pagination->getListFooter(); ?>

				</form>
			</td>
		</tr>
			</table>
		</div>
		<?php

	}
}
?>
