<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesytem.file');

/*
 * Created on Aug 12, 2008
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
class FileTable extends JTable{
	var $id;
	var $date;
	var $filename; // filename;
	var $published;
	var $title;
	var $description;

	function FileTable(& $db) {
		parent :: __construct('#__3dmlw', 'id', $db);
	}

	function removeFile(){
		$file = $this->getFile();
		if( file_exists($file) ){
			@unlink($file);
			return true;
		}else{
			return false;
		}
	}

	function createFolder(){
		mkdir($this->getPath());
	}

	function delete(){
		if($this->removeFile()){
			return parent::delete();
		}

		return false;
	}

	function clear(){
		$vars  = get_object_vars($this);
		foreach ($vars as $k => $value) {
			$this->$k = null;
		}
	}


	function store(){
		if(parent::store()){
			$this->createFolder();
			return true;
		}

		return false;
	}

	function loadPublishedList($limitstart, $limit, $published = null){
		$sql = 'select * from #__3dmlw';

		if(isset($published)){
			switch($published) {
				case true:
					$sql .= ' where published = 1';
					break;
				case false:
					$sql .= ' where published = 0';
				break;
			}
		}
		$db = JFactory :: getDBO();
		$db->setQuery($sql, $limitstart, $limit);
		$list = $db->loadObjectList();
		return $list;
	}

	function count(){
		$sql = "select count(*) from #__3dmlw";
		$db = JFactory :: getDBO();
		$db->setQuery($sql);
		return (int) $db->loadResult();
	}

	function getTitle(){

		if(isset($this->title) && $this->title != ''){
			return $this->title;
		}

		$ext = JFile::getExt($this->filename);

		return basename($this->filename, '.' .$ext);
	}

	function getHref(){
		return JURI::base() . 'components/com_3dmlw/files/' . $this->id . '/' . $this->id . $this->filename;
	}

	function getFile(){
		return $this->getPath() . DS . $this->id . $this->filename;
	}

	function getPath(){
		return JPATH_COMPONENT_SITE . DS . 'files' . DS . $this->id;
	}

	/**
	 * @param $files List of uploaded files.
	 * @return Return false if one of files does not belong
	 */
	function isValidExts($files){

		for ($i = 0; $i < count($files); $i++) {
			if( !FileTable::isValidExt( basename($files['name']) ) )
				return false;
		}

		return true;
	}

	function is3DMLWFile($filename){
		require_once(JPATH_SITE . '/libraries/joomla/filesystem/file.php');
		// jimport('joomla.filesystem.file'); is not working for

		$filename = (isset($filename)) ? $filename : $this->filename;

		$ext = JFile::getExt($filename);

		return JString::strtolower( $ext ) == '3dmlw';
	}

	/**
	 * Returns the name of the 3dmlw file.
	 * @param array $files Array of the uploaded files.
	 * @return mixed Returns the uploaded 3dmlw file otherwise false if it does not
	 * 				exist.
	 */
	function find3DMLWFile($files){
		require_once(JPATH_SITE . '/libraries/joomla/filesystem/file.php');
//	 	jimport('joomla.filesystem.file'); is not working for

		for ($i = 0; $i < count( $files['tmp_name'] ); $i++) {
			$filename = basename( $files['name'][$i] );
			$ext = JFile::getExt($filename);

			if( JString::strtolower( $ext ) == '3dmlw' ){

				$file = array( 'name' => $files['name'][$i], 'tmp_name' => $files['tmp_name'][$i]);

				return $file;
			}
		}

		return false;
	}

	function & upload($file, $title, $description){
		$status = false;

		if(is_uploaded_file($file['tmp_name'])){

			$mlw =& new FileTable(JFactory::getDBO());
			$mlw->filename = basename ( $file['name'] );
			$mlw->title = $title;
			$mlw->description = $description;
			$mlw->published = true;

			if($mlw->store()){
				if( move_uploaded_file( $file['tmp_name'], $mlw->getFile() ) ){
					return $mlw;
				}
			}
		}

		return $status;
	}

	function isValidExt($filename = null, $filter = array()){
		require_once(JPATH_SITE . '/libraries/joomla/filesystem/file.php');
		// jimport('joomla.filesystem.file'); is not working for
		$filter = array( '3dmlw', '3ds', 'an8', 'tga', 'jpg', 'png', 'wav', 'ogg' );

		$filename = (isset($filename)) ? $filename : $this->filename;

		$ext = JFile::getExt($filename);

		return in_array(JString::strtolower( $ext ), $filter);
	}
}
?>